import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _extends from "@babel/runtime/helpers/esm/extends";
import { getAdobeMCVisitorID } from './adobeRepository';
import './patchAnalytics';
var DEFAULT_PROPERTIES = {
  platform: 'web'
};

var mergeUserTraitsTo = function mergeUserTraitsTo(traits) {
  return _extends({}, traits, {
    anonymousId: window.analytics.user().anonymousId(),
    userId: window.analytics.user().id()
  });
};

var mergeAdobeAnalyticsIntegrationsTo =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(integrations) {
    var marketingCloudVisitorId;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return getAdobeMCVisitorID();

          case 2:
            marketingCloudVisitorId = _context.sent;

            if (marketingCloudVisitorId) {
              _context.next = 5;
              break;
            }

            return _context.abrupt("return", integrations);

          case 5:
            return _context.abrupt("return", _extends({}, integrations, {
              'Adobe Analytics': {
                marketingCloudVisitorId: marketingCloudVisitorId
              }
            }));

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function mergeAdobeAnalyticsIntegrationsTo(_x) {
    return _ref.apply(this, arguments);
  };
}();

export var decorateContextWithNeededData =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee2(context) {
    var integrations;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return mergeAdobeAnalyticsIntegrationsTo(context.integrations);

          case 2:
            integrations = _context2.sent;
            return _context2.abrupt("return", _extends({}, context, {
              traits: mergeUserTraitsTo(context.traits),
              integrations: integrations
            }));

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function decorateContextWithNeededData(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
export default {
  identify: function identify() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(function (resolve) {
      var _window$analytics;

      (_window$analytics = window.analytics).identify.apply(_window$analytics, args);

      resolve();
    });
  },
  reset: function reset() {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return new Promise(function (resolve) {
      var _window$analytics2;

      (_window$analytics2 = window.analytics).reset.apply(_window$analytics2, args);

      resolve();
    });
  },
  track: function track() {
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return new Promise(function (resolve) {
      window.analytics.ready(
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee3() {
        var event, propertiesFromArgs, _args$, contextFromArgs, fn, context, properties;

        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                event = args[0], propertiesFromArgs = args[1], _args$ = args[2], contextFromArgs = _args$ === void 0 ? {} : _args$, fn = args[3];
                _context3.next = 3;
                return decorateContextWithNeededData(contextFromArgs);

              case 3:
                context = _context3.sent;
                properties = _extends({}, propertiesFromArgs, {}, DEFAULT_PROPERTIES);
                window.analytics.track(event, properties, context, fn);
                resolve();

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      })));
    });
  }
};